diff --git a/drupal7/sites/all/modules/ldap/ldap_user/tests/ldap_user.test b/drupal7/sites/all/modules/ldap/ldap_user/tests/ldap_user.test
index 32e4a719..e6c49ae0 100644
--- a/drupal7/sites/all/modules/ldap/ldap_user/tests/ldap_user.test
+++ b/drupal7/sites/all/modules/ldap/ldap_user/tests/ldap_user.test
@@ -189,7 +189,6 @@ class LdapUserUnitTests extends LdapTestCase {
       $array_diff = array_diff($user_edit, $desired_result);
     }
     //@todo need better diff, this will give false positives in most cases
-  //  debug('user_edit,desired_result,diff'); debug( array($user_edit, $desired_result, $array_diff));
     $this->assertTrue(count($array_diff) == 0, t('ldapUserConf::entryToUserEdit retrieved correct property, field, and data values.'), $this->testId('ldapUserConf::entryToUserEdit'));
     if (count($array_diff) != 0) {
       debug('ldapUserConf::entryToUserEdit failed.  resulting user edit array:'); debug($user_edit); debug('desired result:'); debug($desired_result); debug('array_diff:'); debug($array_diff);
@@ -212,7 +211,6 @@ class LdapUserUnitTests extends LdapTestCase {
       foreach ($tests as $boolean_result => $attribute_tokens) {
         foreach ($attribute_tokens as $attribute_token) {
           $is_synched = $ldap_user_conf->isSynched($attribute_token, array($prov_event), LDAP_USER_PROV_DIRECTION_TO_DRUPAL_USER);
-          // debug("is_synched_tests: is_synched=$is_synched, attribute_token=$attribute_token, prov_event=$prov_event");
           if ((int)$is_synched !== (int)$boolean_result) {
             $fail = TRUE;
             $debug[$attribute_token] = "isSynched($attribute_token, array($prov_event),
@@ -250,7 +248,6 @@ class LdapUserUnitTests extends LdapTestCase {
     $account->name = 'hpotter';
     $params = array('ldap_context' => 'ldap_user_prov_to_drupal', 'direction' => LDAP_USER_PROV_DIRECTION_TO_DRUPAL_USER);
     list($ldap_entry, $error) = $ldap_user_conf->drupalUserToLdapEntry($account, 'activedirectory1', $params);
-  //  debug('ldap_entry'); debug($ldap_entry);
 
     $account = NULL;
     $user_edit = array('name' => 'hpotter');
@@ -580,7 +577,6 @@ class LdapUserUnitTests extends LdapTestCase {
         if ($field_name) {
           $token_attributes = array();
           ldap_servers_token_extract_attributes($token_attributes,  $test['mapping']['ldap_attr']);
-          //debug('token_attributes'); debug($token_attributes);
           foreach ($token_attributes as $attr_name => $attr_parts ) {
             $this->testFunctions->setFakeServerUserAttribute(
               'activedirectory1',
@@ -595,7 +591,6 @@ class LdapUserUnitTests extends LdapTestCase {
 
         $ldap_user_conf->save();
         $ldap_user_conf = ldap_user_conf('admin', TRUE);
-       // debug("ldap_user_conf in prep field_token=$field_token"); debug($ldap_user_conf->synchMapping); debug($ldap_user_conf->ldapUserSynchMappings);
         ldap_user_ldap_provision_semaphore(NULL, NULL, NULL, TRUE);
         ldap_servers_flush_server_cache();
 
@@ -620,12 +615,8 @@ class LdapUserUnitTests extends LdapTestCase {
               debug('field fail,' . $property_name); debug($user_entity->{$property_name}); debug($test['property_results'][0]); //debug($user_entity);
             }
           }
-          else {
-          // debug("property_name=$property_name not configured to provisionDrupalAccount on drupal user create for direction=$direction and prov_event=$prov_event");
-          }
         }
         if ($field_name) {
-          // debug("property_name=$property_name, prov_event=$prov_event, direction=$direction, field_token=$field_token, sid=$sid, ldap_user_conf->ldapUserSynchMappings $direction - $sid"); debug($ldap_user_conf->ldapUserSynchMappings[$direction][$sid]);
 
           if (in_array($prov_event, $ldap_user_conf->ldapUserSynchMappings[$direction][$field_token]['prov_events'])) { // if intended to synch
             $field_success = isset($user_entity->{$field_name}[LANGUAGE_NONE][0]['value']) &&
@@ -872,7 +863,6 @@ class LdapUserIntegrationTests extends LdapTestCase {
 
       $ldap_user_conf->save();
       $ldap_user_conf = ldap_user_conf('default', TRUE);
-     // debug('ldap_user_conf after provisionToLdapEmailVerification setup'); debug($ldap_user_conf);
 
       variable_set('user_email_verification', TRUE);
       variable_set('user_register', USER_REGISTER_VISITORS); // or USER_REGISTER_ADMINISTRATORS_ONLY, USER_REGISTER_VISITORS_ADMINISTRATIVE_APPROVAL
@@ -1053,10 +1043,8 @@ class LdapUserIntegrationTests extends LdapTestCase {
     $account_options = $drupal_form['basic_to_drupal']['orphanedDrupalAcctBehavior']['#options'];
     $cn_to_account = array();
     $ldap_server = ldap_servers_get_servers('activedirectory1', NULL, TRUE, TRUE);
-   // debug("ldap_server"); debug(is_object($ldap_server));
 
     foreach ($account_options as $account_option => $account_option_text) {
-     // debug("$account_option - $account_option_text");
       $sids = array('activedirectory1');
       $this->prepTestData('hogwarts', $sids, 'provisionToDrupal', 'default');
       $ldap_user_conf->orphanedDrupalAcctBehavior = $account_option;
@@ -1070,17 +1058,13 @@ class LdapUserIntegrationTests extends LdapTestCase {
       $last_clone_username= 'clone' . (LDAP_TEST_USER_ORPHAN_CLONE_COUNT - 1);
       for ($i = 0; $i < LDAP_TEST_USER_ORPHAN_CLONE_COUNT; $i++) { // 70
         $name = "clone" . $i;
-        //debug("create clone $name, activedirectory1");
         $account = $this->createLdapIdentifiedDrupalAccount(
           $ldap_user_conf,
           $name,
           'activedirectory1'
         );
         $cn_to_account[$name] = $account;
-        //debug("new account"); debug($account);
       }
-    //  debug($cn_to_account['clone0']);
-    //  debug($cn_to_account[$last_clone_username]);
 
       // delete 10 ldap entries
       // @FIXME: Wrapper for broken test.
@@ -1091,23 +1075,19 @@ class LdapUserIntegrationTests extends LdapTestCase {
         $clone_last = user_load($clone_last_uid, TRUE);
       }
 
-      //debug("pre ldap delete, clone0 and cloneN $first_clone_username and $last_clone_username"); debug($clone_first);debug($clone_last); //debug($ldap_server->entries);
       $delete = LDAP_TEST_USER_ORPHAN_CLONE_COUNT - LDAP_TEST_USER_ORPHAN_CLONE_REMOVE_COUNT;
       for ($i = 0; $i < $delete; $i++) {
         $name = "clone" . $i;
         $account = $cn_to_account[$name];
-        //debug("delete ldap entry: ". $account->ldap_user_current_dn[LANGUAGE_NONE][0]['value']);
-      //  ?? is it possible the ldap delete hook is causing the drupal user to get populated with empty values?
+        // ?? is it possible the ldap delete hook is causing the drupal user to get populated with empty values?
         $ldap_server->delete($account->ldap_user_current_dn[LANGUAGE_NONE][0]['value']);
       }
 
       $clone_first = user_load($clone_first_uid, TRUE);
       $clone_last = user_load($clone_last_uid, TRUE);
-      //debug("post ldap delete and pre cron, clone0 and cloneN"); debug($clone_first->status);debug($clone_last->status);// debug($ldap_server->entries);
       drupal_cron_run();
       $clone_first = user_load($clone_first_uid, TRUE);
       $clone_last = user_load($clone_last_uid, TRUE);
-      //debug("post cron, clone0 and cloneN"); debug($clone_first->status);debug($clone_last->status); //debug($ldap_server->entries);
       switch ($account_option) {
 
         case 'ldap_user_orphan_do_not_check':
@@ -1115,12 +1095,9 @@ class LdapUserIntegrationTests extends LdapTestCase {
           for ($i = 0; $i < LDAP_TEST_USER_ORPHAN_CLONE_COUNT; $i++) { // 70
             $name = "clone" . $i;
             $test_uids[] = @$cn_to_account[$name]->uid;
-
-            //debug($account);
           }
           $success = TRUE;
           $accounts = user_load_multiple($test_uids);
-         // debug("accounts for $test_id"); debug($accounts);
           foreach ($accounts as $uid => $account) {
             if ($account->status != 1) {
               $success = FALSE;
@@ -1129,16 +1106,11 @@ class LdapUserIntegrationTests extends LdapTestCase {
           }
           if ($success) {
             $success = ($clone_last && $clone_last->status == 1);
-            if (!$success) {
-             // debug("success = $success, status=" . $clone_last->status);
-            }
           }
 
-
         break;
 
         case 'ldap_user_orphan_email' :
-         // debug('ldap_user_orphan_email');
           // test is if email has 10 users and was sent
           $emails = $this->drupalGetMails();
           if (count($emails)) {
@@ -1153,7 +1125,6 @@ class LdapUserIntegrationTests extends LdapTestCase {
 
         case 'user_cancel_block':
         case 'user_cancel_block_unpublish':
-          //debug('user_cancel_block');
           // test is if clone0-clone9 have a status of 0
           // and clone12,11... have a status of 1
           $test_uids = array();
@@ -1183,8 +1154,6 @@ class LdapUserIntegrationTests extends LdapTestCase {
           for ($i = 0; $i < $delete; $i++) { // 70
             $name = "clone" . $i;
             $test_uids[] = @$cn_to_account[$name]->uid;
-
-            //debug($account);
           }
           $success = TRUE;
           $accounts = user_load_multiple($test_uids);
@@ -1276,8 +1245,6 @@ class LdapUserUITests extends LdapTestCase {
     $this->drupalLogin($this->privileged_user);
 
     $ldap_user_conf = ldap_user_conf();
-  //  debug('ldap_user_conf before form submission'); debug($ldap_user_conf);
-
 
     $this->drupalGet('admin/config/people/ldap/user');
 
@@ -1343,7 +1310,6 @@ class LdapUserUITests extends LdapTestCase {
     $this->drupalPost('admin/config/people/ldap/user', $edit, t('Save'));
 
     $ldap_user_conf = ldap_user_conf(NULL, TRUE);
-   // debug('edit'); debug($edit); debug('user conf object after save'); debug($ldap_user_conf);
 
     foreach ($edit_direct_map as $property => $value) {
       $this->assertTrue($ldap_user_conf->{$property} == $value, $property . ' ' . t('field set correctly'), $this->testId('user interface tests'));
diff --git a/drupal7/sites/all/modules/ldap/ldap_views/ldap_views.info b/drupal7/sites/all/modules/ldap/ldap_views/ldap_views.info
index ff917551..2463c874 100644
--- a/drupal7/sites/all/modules/ldap/ldap_views/ldap_views.info
+++ b/drupal7/sites/all/modules/ldap/ldap_views/ldap_views.info
@@ -21,9 +21,9 @@ files[] = handlers/ldap_views_handler_filter.inc
 files[] = handlers/ldap_views_handler_filter_attribute.inc
 files[] = handlers/ldap_views_handler_sort.inc
 files[] = handlers/ldap_views_handler_sort_attribute.inc
-; Information added by Drupal.org packaging script on 2017-03-18
-version = "7.x-2.0"
+; Information added by Drupal.org packaging script on 2017-05-21
+version = "7.x-2.1"
 core = "7.x"
 project = "ldap"
-datestamp = "1489858388"
+datestamp = "1495392789"
 
diff --git a/drupal7/sites/all/modules/ldap/ldap_views/plugins/ldap_views_plugin_query_ldap.inc b/drupal7/sites/all/modules/ldap/ldap_views/plugins/ldap_views_plugin_query_ldap.inc
index b3efc57b..4a80ee6d 100644
--- a/drupal7/sites/all/modules/ldap/ldap_views/plugins/ldap_views_plugin_query_ldap.inc
+++ b/drupal7/sites/all/modules/ldap/ldap_views/plugins/ldap_views_plugin_query_ldap.inc
@@ -238,13 +238,14 @@ class ldap_views_plugin_query_ldap extends views_plugin_query {
  */
     if ($result !== FALSE) { // not an error
         $entries = array_merge($entries, $result);
-        $num_entries += array_shift($result);
+        $num_entries += $result['count'];
+        unset($result['count']);
       }
     }
     if (property_exists($view->query, 'limit')) {
       $limit     = $view->query->limit;
     }
-    $offset      = $view->query->offset;
+    $offset = property_exists($view->query, 'offset')? $view->query->offset : 0;
     $result      = array();
     $sort_fields = array();
     if (!empty($this->orderby)) {
@@ -269,7 +270,7 @@ class ldap_views_plugin_query_ldap extends views_plugin_query {
             switch ($field->options['multivalue']) {
               case 'v-all':
                 // remove 'count' index
-                array_shift($entry[$alias]);
+                unset($entry[$alias]['count']);
                 $entry[$alias] = implode($field->options['value_separator'], $entry[$alias]);
                 break;
               case 'v-count':
@@ -283,6 +284,7 @@ class ldap_views_plugin_query_ldap extends views_plugin_query {
             }
           }
           // order criteria
+          //If the field with alias $alias has a corresponding entry in $sort_fields, copy its value into the data key of $sort_fields for later sorting.
           if (array_key_exists($alias, $sort_fields)) {
             $sort_fields[$alias]['data'][$key] = $entry[$alias];
           }
@@ -305,13 +307,14 @@ class ldap_views_plugin_query_ldap extends views_plugin_query {
       }
       $params[] = &$entries;
 
-      // Some LDAP setups output a 'count' variable first in the array, which changes the array size;
+      // Some LDAP setups output a 'count' variable in the array, which changes the array size;
       // temporarily remove it, sort the arrays, and then put it back.
       if (array_key_exists('count', $entries)) {
-        $countValue = array_shift($entries); // remove the count variable
+        $countValue = $entries['count']; // remove the count variable
+        unset($entries['count']);
         $params[] = &$entries;
         call_user_func_array('array_multisort', $params);
-        array_unshift($params, $countValue);
+        $params['count'] = $countValue;
       }
       else {
         $params[] = &$entries;
diff --git a/drupal7/sites/all/modules/media_ckeditor/includes/media_ckeditor.pages.inc b/drupal7/sites/all/modules/media_ckeditor/includes/media_ckeditor.pages.inc
new file mode 100644
index 00000000..2bc7dc2f
--- /dev/null
+++ b/drupal7/sites/all/modules/media_ckeditor/includes/media_ckeditor.pages.inc
@@ -0,0 +1,72 @@
+<?php
+
+/**
+ * @file
+ * Common pages for the Media Ckeditor module.
+ */
+
+/**
+ * Callback to fetch the markup of a file with certain overrides.
+ */
+function media_ckeditor_rendered_file_in_wysiwyg() {
+
+  // If you would like to see how the $tag_info variable below is built, please
+  // @see media_ckeditor/js/plugins/media/library.js.
+  $tag_info = drupal_get_query_parameters();
+
+  // Introductory sanity/security check.
+  if (!is_numeric($tag_info['fid'])) {
+    throw new Exception('Invalid file id.');
+  }
+
+  // Start with the file object.
+  $file = file_load($tag_info['fid']);
+  if (!$file) {
+    throw new Exception('Could not load media object');
+  }
+
+  // Now attempt to override any specified fields.
+  $fields = array();
+  foreach ($tag_info['fields'] as $key => $values) {
+
+    // Only operate on actual fields.
+    if (strpos($key, 'field_') === 0) {
+      $parsed_field = explode('[', str_replace(']', '', $key));
+      $field_name = $parsed_field[0];
+
+      if (isset($file->{$field_name})) {
+
+        // Make sure this is a valid field.
+        $field_info = field_info_field($field_name);
+        if ($field_info) {
+          $field_language = $parsed_field[1];
+          $column = key($field_info['columns']);
+
+          // Some field values will show up here as a flat string value, so
+          // convert it into a Drupal-friendly field value array.
+          if (is_string($values)) {
+            $values = array(array($column => $values));
+          }
+
+          // The values need to be urldecoded.
+          foreach ($values as $index => &$value) {
+            if (isset($value[$column])) {
+              $value[$column] = urldecode($value[$column]);
+            }
+          }
+
+          // Override the field on the file entity.
+          $fields[$field_name] = array($field_language => $values);
+        }
+      }
+    }
+  }
+
+  // Make sure it is indicated that this is a wysiwyg rendering.
+  $file->override['wysiwyg'] = TRUE;
+
+  // Now simply print the file entity and exit.
+  $build = media_ckeditor_render_file_with_overrides($file, $tag_info['view_mode'], $fields);
+  print drupal_render($build);
+  drupal_page_footer();
+}
diff --git a/drupal7/sites/all/modules/media_ckeditor/js/plugins/media/library.js b/drupal7/sites/all/modules/media_ckeditor/js/plugins/media/library.js
index 7bc8007b..feedf055 100644
--- a/drupal7/sites/all/modules/media_ckeditor/js/plugins/media/library.js
+++ b/drupal7/sites/all/modules/media_ckeditor/js/plugins/media/library.js
@@ -7,6 +7,44 @@
 (function ($) {
   Drupal.media = Drupal.media || {};
 
+  /**
+   * Attaches 'insert' button to media widget.
+   */
+  Drupal.behaviors.mediaWidgetInsert = {
+    attach: function (context, settings) {
+      if (Drupal.ckeditorInstance && Drupal.settings.media_ckeditor && Drupal.settings.media_ckeditor.wysiwyg_insert) {
+        // Only add buttons on fields that have been configured so, by
+        // consulting the Drupal.settings.media_ckeditor.wysiwyg_insert var.
+        for (var fieldName in Drupal.settings.media_ckeditor.wysiwyg_insert) {
+          var fieldId = '#edit-' + fieldName.replace(/_/g, '-');
+          // Within the field markup, look for the table of files.
+          $(fieldId, context).find('.media-widget').once('mediaInsertButton', function() {
+            // For each file, check to see if there is a file ID.
+            if ($(this).find('input.fid').val() != 0) {
+              // Now we add the button next to "Remove".
+              var insertButton = $('<a class="media-insert button">' + Drupal.t('Insert') + '</a>')
+                .click(function(e) {
+                  e.preventDefault();
+                  var fid = $(this).parent().parent().find('.fid').val();
+                  var mediaFile = {fid: fid}
+                  Drupal.ckeditorInstance.mediaInsert = {mediaFiles: [mediaFile]};
+                  Drupal.ckeditorInstance.execCommand('media');
+                });
+              // Insert the button, differently for single vs. multi value.
+              var multiValue = $(fieldId + ' table', context).length;
+              if (multiValue) {
+                insertButton.insertBefore($(this).parent().parent().find('input.remove'));
+              }
+              else {
+                insertButton.insertBefore($(this).find('input.remove'));
+              }
+            }
+          });
+        }
+      }
+    }
+  };
+
   Drupal.settings.ckeditor.plugins['media'] = {
     /**
      * Execute the button.
@@ -26,13 +64,22 @@
         else {
           $alreadyInsertedMedia = jQuery(data.node).find('[data-media-element]');
         }
-        if ($alreadyInsertedMedia.length) {
-          // Change the view mode for already-inserted media.
+        // First check to see if we are using an Insert button.
+        if (typeof Drupal.ckeditorInstance.mediaInsert !== 'undefined') {
+          var mediaFile = Drupal.ckeditorInstance.mediaInsert.mediaFiles[0];
+          delete Drupal.ckeditorInstance.mediaInsert;
+          Drupal.media.popups.mediaStyleSelector(mediaFile, function (mediaFiles) {
+            Drupal.settings.ckeditor.plugins['media'].insertMediaFile(mediaFile, mediaFiles, CKEDITOR.instances[instanceId]);
+          }, settings['global']);
+        }
+        // Next check to see if we are editing already-inserted media.
+        else if ($alreadyInsertedMedia.length) {
           var mediaFile = Drupal.media.filter.extract_file_info($alreadyInsertedMedia);
           Drupal.media.popups.mediaStyleSelector(mediaFile, function (mediaFiles) {
             Drupal.settings.ckeditor.plugins['media'].insertMediaFile(mediaFile, mediaFiles, CKEDITOR.instances[instanceId]);
           }, settings['global']);
         }
+        // Otherwise we are embedding new media.
         else {
           Drupal.media.popups.mediaBrowser(function (mediaFiles) {
             Drupal.settings.ckeditor.plugins['media'].mediaBrowserOnSelect(mediaFiles, instanceId);
@@ -54,7 +101,58 @@
       return;
     },
 
-    insertMediaFile: function (mediaFile, formattedMedia, ckeditorInstance) {
+    insertMediaFile: function (mediaFile, formattedMedia, ckeditorInstance, fullyRenderedFile) {
+
+      // See if we should use ajax to get the fully rendered file.
+      if (typeof fullyRenderedFile === 'undefined' &&
+          Drupal.settings.media_ckeditor.fully_rendered_files) {
+
+        $.ajax({
+          url: Drupal.settings.basePath + 'media/rendered-in-wysiwyg',
+          type: 'GET',
+          data: {
+            fid: mediaFile.fid,
+            view_mode: formattedMedia.type,
+            fields: formattedMedia.options
+          },
+          success: function(html) {
+            // To work around an IE issue, preload any image. The issue is
+            // that IE requests the image 2 times, and one request gets a 503,
+            // causing a broken image icon in the WYSIWYG instead of the actual
+            // image.
+            var $images = $(html).find('img');
+            if (!$images.length || $(html).find('picture').length) {
+              // If there are no images, just insert the html immediately, by
+              // re-calling this function with the ajax-retrieved HTML.
+              Drupal.settings.ckeditor.plugins['media'].insertMediaFile(mediaFile, formattedMedia, ckeditorInstance, html);
+            }
+            else {
+              // Otherwise do the same, but only after the first image preloads.
+              // Possible future improvement might be to handle multiple images
+              // instead of just the first, but even better would be to remove
+              // this workaround entirely, when/if IE's behavior changes.
+              var image = new Image();
+              image.onload = function() {
+                Drupal.settings.ckeditor.plugins['media'].insertMediaFile(mediaFile, formattedMedia, ckeditorInstance, html);
+              }
+              image.src = $images.first().attr('src');
+            }
+          },
+          error: function(data) {
+            // Fallback to whatever the HTML was already going to be.
+            Drupal.settings.ckeditor.plugins['media'].insertMediaFile(mediaFile, formattedMedia, ckeditorInstance, formattedMedia.html);
+          }
+        });
+
+        // Stop for now, because the callback above re-calls this same function.
+        return;
+      }
+
+      // See if we already used ajax to get the fully rendered file.
+      if (typeof fullyRenderedFile !== 'undefined') {
+        formattedMedia.html = fullyRenderedFile;
+      }
+
       // Customization of Drupal.media.filter.registerNewElement().
       var element = Drupal.media.filter.create_element(formattedMedia.html, {
         fid: mediaFile.fid,
@@ -197,4 +295,22 @@
     }
   };
 
+  // If media_ckeditor is configured to render items in the wysiwyg as full
+  // rendered file entities, we need to completely hijack a function from
+  // media_wysiwyg.filter.js.
+  if (Drupal.settings.media_ckeditor.fully_rendered_files) {
+
+    // Replaces function of the same name, from media_wysiwyg.filter.js.
+    Drupal.media.filter.replacePlaceholderWithToken = function(content) {
+
+      var $placeholder = $(content);
+      if ($placeholder.hasClass('media-element')) {
+        var macro = Drupal.media.filter.create_macro($placeholder);
+        Drupal.media.filter.ensure_tagmap();
+        Drupal.settings.tagmap[macro] = content;
+        return macro;
+      }
+      return content;
+    }
+  }
 })(jQuery);
diff --git a/drupal7/sites/all/modules/media_ckeditor/js/plugins/media/plugin.js b/drupal7/sites/all/modules/media_ckeditor/js/plugins/media/plugin.js
index a82f6edb..8b94419e 100644
--- a/drupal7/sites/all/modules/media_ckeditor/js/plugins/media/plugin.js
+++ b/drupal7/sites/all/modules/media_ckeditor/js/plugins/media/plugin.js
@@ -17,6 +17,7 @@ For licensing, see LICENSE.html or http://ckeditor.com/license
     // disabled by default.
     hasWidgetSupport: false,
     mediaLegacyWrappers: false,
+    hidpi: true,
     onLoad: function() {
       // Check if this instance has widget support.
       mediaPluginDefinition.hasWidgetSupport = typeof(CKEDITOR.plugins.registered.widget) != 'undefined';
@@ -37,9 +38,9 @@ For licensing, see LICENSE.html or http://ckeditor.com/license
             content: ''
           };
           var selection = editor.getSelection();
-
           if (selection) {
             data.node = selection.getSelectedElement();
+
             if (data.node) {
               data.node = data.node.$;
             }
@@ -56,6 +57,24 @@ For licensing, see LICENSE.html or http://ckeditor.com/license
               data.content = data.node.parentNode.innerHTML;
             }
           }
+
+          // If we are inside another media element, we need to move the cursor to the end of the element
+          var selected_element = selection.getStartElement();
+          var parent = selected_element.getParent();
+          //if we are inside "a" tag and inside "span" (with class media-element)
+          if (selected_element.is('a') && parent.is('span') && parent.hasClass('media-element')) {
+            selection.selectElement(parent);
+            selected_ranges = selection.getRanges();
+            selected_ranges[0].collapse(false);
+            selection.selectRanges(selected_ranges);
+          }
+          //if we are outside "a" tag but inside "span" (with class media-element)
+          else if (selected_element.is('span') && selected_element.hasClass('media-element')) {
+              selection.selectElement(selected_element);
+              selected_ranges = selection.getRanges();
+              selected_ranges[0].collapse(false);
+              selection.selectRanges(selected_ranges);
+          }
           Drupal.settings.ckeditor.plugins['media'].invoke(data, Drupal.settings.ckeditor.plugins['media'], editor.name);
         }
       });
@@ -88,8 +107,7 @@ For licensing, see LICENSE.html or http://ckeditor.com/license
       editor.ui.addButton( 'Media',
       {
         label: 'Add media',
-        command: 'media',
-        icon: this.path + 'images/icon.gif'
+        command: 'media'
       });
 
       var ckeditorversion = parseFloat(CKEDITOR.version);
diff --git a/drupal7/sites/all/modules/media_ckeditor/media_ckeditor.ckeditor.inc b/drupal7/sites/all/modules/media_ckeditor/media_ckeditor.ckeditor.inc
index 417dfbb3..8cf5063c 100644
--- a/drupal7/sites/all/modules/media_ckeditor/media_ckeditor.ckeditor.inc
+++ b/drupal7/sites/all/modules/media_ckeditor/media_ckeditor.ckeditor.inc
@@ -16,7 +16,7 @@ function media_ckeditor_ckeditor_plugin_alter(&$plugins) {
     'path' => '%base_path%' . drupal_get_path('module', 'media_ckeditor') . '/js/plugins/media/',
     'buttons' => array(
       'Media' => array(
-        'icon' => 'images/icon.gif',
+        'icon' => 'icons/media.png',
         'label' => 'Add media',
       ),
     ),
diff --git a/drupal7/sites/all/modules/media_ckeditor/media_ckeditor.info b/drupal7/sites/all/modules/media_ckeditor/media_ckeditor.info
index 9fb0ddc6..50ecdc77 100644
--- a/drupal7/sites/all/modules/media_ckeditor/media_ckeditor.info
+++ b/drupal7/sites/all/modules/media_ckeditor/media_ckeditor.info
@@ -15,9 +15,9 @@ test_dependencies[] = ckeditor
 test_dependencies[] = views
 test_dependencies[] = ctools
 
-; Information added by Drupal.org packaging script on 2017-01-15
-version = "7.x-2.0-rc3"
+; Information added by Drupal.org packaging script on 2017-05-24
+version = "7.x-2.1"
 core = "7.x"
 project = "media_ckeditor"
-datestamp = "1484494686"
+datestamp = "1495629657"
 
